from src.interfaces import IRomanConverter


class RomanNumerals(IRomanConverter):
    def to_roman(self, num):
        if not isinstance(num, int):
            raise ValueError("Eingabe muss eine ganze Zahl sein")
        if num <= 0 or num >= 4000:
            raise ValueError("Zahl muss zwischen 1 und 3999 liegen")

        val = [
            (1000, "M"), (900, "CM"), (500, "D"), (400, "CD"),
            (100, "C"), (90, "XC"), (50, "L"), (40, "XL"),
            (10, "X"), (9, "IX"), (5, "V"), (4, "IV"),
            (1, "I")
        ]

        result = ""
        for (value, numeral) in val:
            while num >= value:
                result += numeral
                num -= value
        return result