from src.Calculator import Calculator
from src.Count_ED import Counter
from src.Roman_Converter import RomanConverter, int_to_roman
from src.String_Calculator import StringCalculator

if __name__ == "__main__":
    # Erstelle eine Instanz der Calculator-Klasse
    calc = Calculator()

    # Eine Liste von Test-Ausdrücken, die überprüft werden sollen
    test_expressions = [
        "2+3",      # Einfacher Additionstest
        "10-4/2",   # Test mit Division und Subtraktion
        "(3+5)*2",  # Komplexerer Ausdruck mit Klammern
        "3++5",     # Ungültiger Ausdruck (doppelte Operatoren)
        "3--5",     # Ungültiger Ausdruck (doppelte Operatoren)
        "10*/2",    # Ungültiger Ausdruck (Operatorenkombinationen)
        "5/0",      # Division durch Null (Fehler)
        "(3+5))",   # Ungültiger Ausdruck (zu viele Klammern)
        "abc",      # Ungültiger Ausdruck (nur Buchstaben)
        "-3*-3"     # Gültiger Ausdruck mit Vorzeichen
    ]

    # Schleife, um alle Test-Ausdrücke zu durchlaufen
    for expr in test_expressions:
        try:
            # Versuche, den Ausdruck zu berechnen und gebe das Ergebnis aus
            print(f"Eingabe: '{expr}' → Ausgabe: {calc.calculate(expr)}")
        except Exception as e:
            # Wenn ein Fehler auftritt, gebe die Fehlermeldung aus
            print(f"Eingabe: '{expr}' → Fehler: {e}")
print("______________________________________________________________")
if __name__ == "__main__":
    counter = Counter()
    test_strings = ["Decker", "", "Hallo", "Der Esel", "D", "E", "d", "e"]

    for string in test_strings:
        print(f"Eingabe: '{string}' → Ausgabe: {counter.count_ed(string)}")

print("______________________________________________________________")

if __name__ == "__main__":
    converter = RomanConverter()
    # Test römische Zahl in Dezimalzahl umwandeln
    print("Test römische Zahl in Dezimalzahl umwandeln")
    print(converter.roman_to_int("MCMXCIV"))  # Ausgabe: 1994
    print(converter.roman_to_int("XIV"))  # Ausgabe: 14
    print(converter.roman_to_int("CDXLIV"))  # Ausgabe: 444

    # Test Dezimalzahl in römische Zahl umwandeln
    print("Test Dezimalzahl in römische Zahl umwand")
    print(int_to_roman(1994))  # Ausgabe: MCMXCIV
    print(int_to_roman(14))    # Ausgabe: XIV
    print(int_to_roman(444))   # Ausgabe: CDXLIV

print("______________________________________________________________")

if __name__ == "__main__":
    # ==== StringCalculator ====
    sc = StringCalculator()
    test_inputs = [
        "1,2,3",                  # 6
        "1\n2,3",                 # 6
        "//;\n1;2",              # 3
        "//[***]\n1***2***3",    # 6
        "2,1001",                # 2 (1001 wird ignoriert)
        "-1,2,-3",               # Exception
        "",                      # 0
        "  ",                    # 0
    ]

    for s in test_inputs:
        try:
            print(f"Eingabe: '{s}' → Ausgabe: {sc.add(s)}")
        except Exception as e:
            print(f"Eingabe: '{s}' → Fehler: {e}")

print("______________________________________________________________")