# Testfälle roman_to_int, str -> int

# 1. Einzelne römische Ziffern
# Eingabe: "I" → Erwartete Ausgabe: 1
# Eingabe: "V" → Erwartete Ausgabe: 5
# Eingabe: "X" → Erwartete Ausgabe: 10
# Eingabe: "L" → Erwartete Ausgabe: 50
# Eingabe: "C" → Erwartete Ausgabe: 100
# Eingabe: "D" → Erwartete Ausgabe: 500
# Eingabe: "M" → Erwartete Ausgabe: 1000

#2. Mehrere gleiche Ziffern hintereinander (einfache Addition)
# Eingabe: "II" → Erwartete Ausgabe: 2
# Eingabe: "XX" → Erwartete Ausgabe: 20
# Eingabe: "CC" → Erwartete Ausgabe: 200
# Eingabe: "MM" → Erwartete Ausgabe: 2000

#3. Subtraktive Notation
# Eingabe: "IV" → Erwartete Ausgabe: 4
# Eingabe: "IX" → Erwartete Ausgabe: 9
# Eingabe: "XL" → Erwartete Ausgabe: 40
# Eingabe: "XC" → Erwartete Ausgabe: 90
# Eingabe: "CD" → Erwartete Ausgabe: 400
# Eingabe: "CM" → Erwartete Ausgabe: 900

#4. Komplexe Zahlen
# Eingabe: "MCMXCIV" → Erwartete Ausgabe: 1994
#Eingabe: "XIV" → Erwartete Ausgabe: 14
#Eingabe: "CDXLIV" → Erwartete Ausgabe: 444


import unittest
from src.Roman_Converter import RomanConverter  # Importiere die zu testende Klasse

class TestRomanConverter(unittest.TestCase):
    def setUp(self):
        self.converter = RomanConverter()

    def test_single_digits(self):
        self.assertEqual(self.converter.roman_to_int("I"), 1)
        self.assertEqual(self.converter.roman_to_int("V"), 5)
        self.assertEqual(self.converter.roman_to_int("X"), 10)

    def test_multiple_digits(self):
        self.assertEqual(self.converter.roman_to_int("II"), 2)
        self.assertEqual(self.converter.roman_to_int("XX"), 20)
        self.assertEqual(self.converter.roman_to_int("VI"), 6)

    def test_subtractive_notation(self):
        self.assertEqual(self.converter.roman_to_int("IV"), 4)
        self.assertEqual(self.converter.roman_to_int("IX"), 9)
        self.assertEqual(self.converter.roman_to_int("XL"), 40)
        self.assertEqual(self.converter.roman_to_int("XC"), 90)

    def test_complex_numbers(self):
        self.assertEqual(self.converter.roman_to_int("MCMXCIV"), 1994)
        self.assertEqual(self.converter.roman_to_int("CDXLIV"), 444)

if __name__ == "__main__":
    unittest.main()